/*
/*
 *  C64_GP32.i by Mike Dawson, adapted from:
 *  C64_x.i - Put the pieces together, X specific stuff
 *f
 *  Frodo (C) 1994-1997,2002 Christian Bauer
 *  Unix stuff by Bernd Schmidt/Lutz Vieweg
 */

#define abs(x) ((x)<0 ? -(x) : (x))
#include "main.h"

#include <stdio.h>
#include "1541d64.h"
#include "IEC.h"

#include <stdlib.h>
#include <sys/stat.h> 
#include <sys/dir.h> 
#include <unistd.h>
#include <dirent.h>

#include <time.h>
#include "prefs.h"

#include "menu_bin.h"

//FPS Counter
u64 tickOld;
int fps;
int theFPS;
int Now, LastFrame;
#define TICKS_PER_SEC (268123480)
#define TICKS_PER_FRAME (TICKS_PER_SEC/50)
u64 tim;
int saveAudio;
int FForward=0;
int FrameSkip;
int Seconds = 0;
bool screenDark=0;
bool soundCheck = false;
char theDrivePath[256];
bool pauseSystem = false;
int fileTypes=0;
int mountOnly=0;

int menuNum=0;

char progNames[144][17];
char progTypes[144];
int progsize[144];
char diskname[17];
int numprogs=-1;
int currentProg;
int gotprogs=0;

bool resetLoad = false; // tell to load after reset
char resetLoadString[255]; // what to load after reset
u64 resetLoadTimer=0;

#define MATRIX(a,b) (((a) << 3) | (b))

uint8_t* bottom_fb;
int penDown=0;
int oldPenDown=0;

//  Stuff to read .d64 file (I hope)
//  http://8bitbus.blogspot.co.uk/2011/06/how-to-parse-d64-files-part-1.html

void readD64(const char* filename){
    gotprogs=0;
    int directorySector = (18-1) * 21 + 1;
    int offset = 256 * directorySector;
    int offset1 = 256 * directorySector - 112;
    char dirtrack, dirsector, tipe, track, sector;
    char programname[17];
    
    struct stat st;
    stat(filename, &st);

    FILE *filepointer = fopen(filelist[currentFile], "rb");

    
    fseek(filepointer, offset1, SEEK_SET );
    fread( &programname ,16,1,filepointer);
    for(int p=0; p<16; p++){
        diskname[p]=programname[p];
        if(diskname[p]==160){diskname[p]=0;}
    }
    diskname[16]=0; // terminate string regardless of length
    
    int n=0;
    numprogs=0;
    int something=0;
    
    for(int j=0; j<143; j++){
        
        if(something++ == 8){
            something=0;
            j += 16;
        }
        
        fseek(filepointer, offset+(j*32), SEEK_SET  );
        
        fread( &dirtrack, 1,1,filepointer);
        fread( &dirsector, 1,1,filepointer);
        fread( &tipe, 1,1,filepointer);
        fread( &track, 1,1,filepointer);
        fread( &sector, 1,1,filepointer);
        
        fread( &programname ,16,1,filepointer);
        for(int p=0; p<16; p++){
            progNames[n][p]=programname[p];
            if(progNames[n][p]==160){progNames[n][p]=0;}
        }
        
        int temp=0;
        // Read another 8 bytes and not use them
        for(int j1=0; j1<9; j1++){
            fread( &temp, 1,1,filepointer);
        }
        
        int b1=0, b2=0;
        fread( &b1, 1,1,filepointer);
        fread( &b2, 1,1,filepointer);
        
        progNames[n][16]=0;
        progTypes[n]=tipe;
        progsize[n] = b1 + (b2*256);
        if(progTypes[n] != 0){
            numprogs++;
        }
        if(tipe!=0){
            n++;
            //if(n&=8)j+=16;
        }
    }
    fclose(filepointer);
    
    if(numprogs != 0) gotprogs=1;
    
}

// ^ .d64 reader ^

int GetTicks(void) 
{ 
    return svcGetSystemTick();
} 

char filelist[1000][128];  // 100 strings of up to 255 characters each
int fileType[1000];
int filesInList;
int filesGot;
int currentFile;
int oldKeys;
int DiskSelected;
int currentDrive=0;
int showMenu=0;
int menuItem=1;
int subMenu=0;
int settingsMenu=0;
int subMenuItems[8]={5,3,4,0,0,0,0,0};
char currentPath[255]="sdmc:/";

int keyButton[3];


void readFileList(){ // const char* thisDir

//strcat(theDrivePath, thisDir);
chdir(currentPath);
getcwd(currentPath, 255);
int n=0;    
DIR *pdir;
struct direct *pent;
//chdir(thisDir);
pdir=opendir(".");

if (pdir){
    if(strcmp(currentPath,"sdmc:/")){
        strcpy(filelist[n],"../");
        fileType[n]=4; // Folder
        n++;
    }
	while ((pent=readdir(pdir))!=NULL) {
 		if(!strncmp("._", &pent->d_name[0], 2) )
     		continue;
 		if(pent->d_type == DT_DIR){
    		//iprintf("[%s]\n", pent->d_name);
            sprintf(filelist[n],"%s/", pent->d_name);
            fileType[n]=4; // Folder
            n++;
        }else{
    		//iprintf("%s\n", pent->d_name);
            int len = strlen(pent->d_name)-4;
            if(
                (fileTypes==0 && (
                strcasecmp(".d64",&pent->d_name[len])==0
               || strcasecmp(".t64",&pent->d_name[len])==0
               || strcasecmp(".prg",&pent->d_name[len])==0
                )) || (fileTypes==1 && strcasecmp(".fss",&pent->d_name[len])==0)
            ){
                sprintf(filelist[n],"%s", pent->d_name);
                if(strcasecmp(".d64",&pent->d_name[len])==0){fileType[n]=1;}
                if(strcasecmp(".t64",&pent->d_name[len])==0){fileType[n]=5;}
                if(strcasecmp(".prg",&pent->d_name[len])==0){fileType[n]=2;}
                if(strcasecmp(".fss",&pent->d_name[len])==0){fileType[n]=3;}
                // filestype 4 = folder
                n++;
            }
        }
	}
	closedir(pdir);    
    filesInList = n;
}

filesGot=0;
if(n!=0)filesGot=1;
}











extern void print(char *s);

//static int time_start=0;
int total_frames=0;

int current_joystick=1;


/*
 *  Constructor, system-dependent things
 */

void C64::c64_ctor1(void)
{
   // StartTimers();
    
}

void C64::c64_ctor2(void)
{
}


/*
 *  Destructor, system-dependent things
 */

void C64::c64_dtor(void)
{
}


/*
 *  Start main emulation thread
 */

void C64::Run(void)
{
    //uint8_t* bottom_fb = gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);

	// Reset chips
    TheCPU->Reset();
	TheSID->Reset();
	TheCIA1->Reset();
	TheCIA2->Reset();
	TheCPU1541->Reset();

	// Patch kernal IEC routines
	orig_kernal_1d84 = Kernal[0x1d84]; 
	orig_kernal_1d85 = Kernal[0x1d85];
	PatchKernal(ThePrefs.FastReset, ThePrefs.Emul1541Proc);
	quit_thyself = false;
	thread_func();
}

char kbd_feedbuf[255];
int kbd_feedbuf_pos;

void kbd_buf_feed(const char *s) {
	strcpy(kbd_feedbuf, s);
	kbd_feedbuf_pos=0;
}

void kbd_buf_update(C64 *TheC64) {
	if((kbd_feedbuf[kbd_feedbuf_pos]!=0)
			&& TheC64->RAM[198]==0) {
		TheC64->RAM[631]=kbd_feedbuf[kbd_feedbuf_pos];
		TheC64->RAM[198]=1;

		kbd_feedbuf_pos++;
	}
}

void load_prg(C64 *TheC64, uint8 *prg, int prg_size) {
	uint8 start_hi, start_lo;
	uint16 start;
	int i;

	start_lo=*prg++;
	start_hi=*prg++;
	start=(start_hi<<8)+start_lo;

	for(i=0; i<(prg_size-2); i++) {
		TheC64->RAM[start+i]=prg[i];
	}
} 


void C64::poll_input(){
	hidScanInput();
//	u32 keys_down = hidKeysDown();
	u32 keys = hidKeysHeld();
//	u32 rkeys  = hidKeysUp();

    
if(gotprogs == 1){
	if(oldKeys != keys){
        if( keys & KEY_UP ){ currentProg--; }
        if( keys & KEY_DOWN ){ currentProg++; }
        if(currentProg <0){ currentProg=0; }
        if(currentProg >numprogs-1){ currentProg=numprogs-1; }

        if( keys & KEY_B ){
            gotprogs=0;
        }
        
        if( keys & KEY_A ){
            Prefs *prefs = new Prefs(ThePrefs);
            strcpy(prefs->DrivePath[0], filelist[currentFile]);
            this->NewPrefs(prefs);
            ThePrefs = *prefs;
            delete prefs;
            strcpy(kbd_feedbuf, "");
            kbd_feedbuf_pos=0;
            sprintf(resetLoadString,"LOAD\"%s\",8\rRUN\r",progNames[currentProg]);
            resetLoad=true;
            resetLoadTimer = svcGetSystemTick() + (268123324); // one second in the future!
            //strcpy(prefs->DrivePath[0], filelist[currentFile]);
            numprogs = -1;
            this->Reset();
            Resume();
            showMenu=0;
            filesGot=0;
            menuNum=0;
            numprogs=-1;
            gotprogs=0;
        }// A
        
    }
}
    
if(filesGot==1 && gotprogs == 0){
    screenDark=0;
    Seconds=0;
	if(oldKeys != keys){
        if( keys & KEY_LEFT ) { currentFile-=10; if(currentFile<0){currentFile=0;}}
        if( keys & KEY_RIGHT ) { currentFile+=10; if( currentFile > filesInList-1 ){currentFile=filesInList-1;}}

        if( keys & KEY_A){ // load file
            
            
            
            if(fileType[currentFile] == 1){
                if(mountOnly==0){
                    readD64(filelist[currentFile]);
                    for(int i=numprogs; i>=0; i--){
                        if((progTypes[i]&3) == 2){
                            currentProg = i;
                        }
                    }

                }else{
                    Prefs *prefs = new Prefs(ThePrefs);
                    strcpy(prefs->DrivePath[0], filelist[currentFile]);
                    this->NewPrefs(prefs);
                    ThePrefs = *prefs;
                    delete prefs;
                    kbd_feedbuf[0]=0;
                    Resume();
                    showMenu=0;
                    filesGot=0;
                    menuNum=0;
                }
            }


            // if.prg, load directly
            if(fileType[currentFile] == 2){
            
                Prefs *prefs = new Prefs(ThePrefs);
                strcpy(prefs->DrivePath[0], filelist[currentFile]);
                this->NewPrefs(prefs);
                ThePrefs = *prefs;
                delete prefs;
                strcpy(kbd_feedbuf, "");
                kbd_feedbuf_pos=0;
                sprintf(resetLoadString,"RUN\r");
                resetLoad=true;
                resetLoadTimer = svcGetSystemTick() + (268123324); // one second in the future!
                this->Reset();
                Resume();
                showMenu=0;
                filesGot=0;
                menuNum=0;
                numprogs=-1;
                gotprogs=0;
            
            }
            
            // if .fss, load state
            if(fileType[currentFile] == 3){
                LoadSnapshot(filelist[currentFile]);
                Prefs *prefs = new Prefs(ThePrefs);
                strcpy(prefs->DrivePath[0], filelist[currentFile]);
                this->NewPrefs(prefs);
                ThePrefs = *prefs;
                delete prefs;
                kbd_feedbuf[0]=0;
                Resume();
                showMenu=0;
                filesGot=0;
                menuNum=0;
                numprogs=-1;
                gotprogs=0;

            }
            
            if(fileType[currentFile] == 5){
                if(mountOnly==0){

                    Prefs *prefs = new Prefs(ThePrefs);
                    strcpy(prefs->DrivePath[0], filelist[currentFile]);
                    this->NewPrefs(prefs);
                    ThePrefs = *prefs;
                    delete prefs;
                    strcpy(kbd_feedbuf, "");
                    kbd_feedbuf_pos=0;
                    sprintf(resetLoadString,"LOAD\"*\",8\rRUN\r");
                    resetLoad=true;
                    resetLoadTimer = svcGetSystemTick() + (268123324); // one second in the future!
                    numprogs = -1;
                    this->Reset();
                    Resume();
                    showMenu=0;
                    filesGot=0;
                    menuNum=0;
                    numprogs=-1;
                    gotprogs=0;
                    
                    
                }else{
                    Prefs *prefs = new Prefs(ThePrefs);
                    strcpy(prefs->DrivePath[0], filelist[currentFile]);
                    this->NewPrefs(prefs);
                    ThePrefs = *prefs;
                    delete prefs;
                    kbd_feedbuf[0]=0;
                    Resume();
                    showMenu=0;
                    filesGot=0;
                    menuNum=0;
                }
            }
            
            
            // if folder, chdir and reload list
            if(fileType[currentFile] == 4){
                strcat(currentPath,filelist[currentFile]);
                readFileList();
                currentFile=0;
            }
        }
        
    }
} // filesgot
    

    // Menu On/Off
    
    if(showMenu && gotprogs == 0){
        if( keys & KEY_UP    ){
            if(!(oldKeys & KEY_UP)){
                if(filesGot==1){
                    currentFile--;
                    if( currentFile <0 ){currentFile=0;}
                }else{
                    menuItem--;
                }
            }
        }
        if( keys & KEY_DOWN  ){
            if(!(oldKeys & KEY_DOWN)){
                if(filesGot==1){
                    currentFile++;
                    if( currentFile > filesInList-1 ){currentFile=filesInList-1;}
                }else{
                    menuItem++;
                }
            }
        }
        if(menuItem < 0) {menuItem = 0;}
        if(menuNum==0){
            if(menuItem > 3) {menuItem = 3;}
        }else{
            if(menuItem > subMenuItems[settingsMenu]) {menuItem = subMenuItems[settingsMenu];}
        }

        
        if( keys & KEY_LEFT ){
            if(!(oldKeys & KEY_LEFT)){
                if(menuNum==1 && settingsMenu==2){
                    menuItem -= 3;
                    if(menuItem < 0) menuItem = 0;
                }
            }
        }
        if( keys & KEY_RIGHT ){
            if(!(oldKeys & KEY_RIGHT)){
                if(menuNum==1 && settingsMenu==2){
                    menuItem += 3;
                    if(menuItem > 4) menuItem = 4;
                }
            }
        }

        
        
        if( keys & KEY_A ){
            if(!(oldKeys & KEY_A)){
                switch(menuNum){
                    case 0:
                        if(menuItem==0){
                            Resume(); // resume the C64
                            showMenu = 0; // Hide the menu;
                        }

                        if(menuItem==1){
                            menuNum = 1; // switch to settings menu
                            settingsMenu = 0;
                            menuItem=0;
                        }
                        if(menuItem==2){ // Reset emulator
                            this->Reset();
                            Resume();
                            showMenu=0;
                            filesGot=0;
                            menuNum=0;
                            numprogs=-1;
                            gotprogs=0;
                            break;
                        }
                        if(menuItem==3){ // Exit emulator
                            Pause(); // exit audio safely..
                            // Save Prefs
                            Prefs *prefs = new Prefs(ThePrefs);
                            prefs->Save("/c64/prefs.ini");
                            delete prefs;
                            // Save Snapshot
                            SaveSnapshot("/c64/continue.fss");
                            quit_thyself=1;
                            break;
                        }
                    break;
                    case 1:
                        switch(settingsMenu){
                            case 0: // Disk
                                if(menuItem == 0){ // switch true 1541 emu
                                    if(ThePrefs.Emul1541Proc){
                                        ThePrefs.Emul1541Proc = false;
                                        Prefs *prefs = new Prefs(ThePrefs);
                                        prefs->Save("/c64/prefs.ini");
                                        delete prefs;
                                    }else{
                                        ThePrefs.Emul1541Proc = true;
                                        Prefs *prefs = new Prefs(ThePrefs);
                                        prefs->Save("/c64/prefs.ini");
                                        delete prefs;
                                    }
                                    this->PatchKernal(ThePrefs.FastReset, ThePrefs.Emul1541Proc);
                                    strcpy(kbd_feedbuf, "");
                                    kbd_feedbuf_pos=0;
                                }
                                if(menuItem == 1){ // Load game
                                    Pause(); // pause the C64
                                    mountOnly=0;
                                    fileTypes=0;
                                    readFileList();
                                    currentDrive=0;
                       //             showMenu = 0;//-showMenu;
                                    TheDisplay->Update(1);
                                }
                                if(menuItem == 2){ // Mount Disk
                                    Pause(); // pause the C64
                                    mountOnly=1;
                                    fileTypes=0;
                                    readFileList();
                                    currentDrive=0;
                        //            showMenu = 0;//-showMenu;
                                    TheDisplay->Update(1);
                                }
                                if(menuItem == 3){ // Load Snapshot
                                    Pause(); // pause the C64
                                    fileTypes=1;
                                    readFileList();
                                    currentDrive=0;
                                    //showMenu = 0;//-showMenu;
                                    TheDisplay->Update(1);
                                }
                                if(menuItem == 4){ // Save Snapshot
                                    char tempDrivePath[256];
                                    strcpy(tempDrivePath, filelist[currentFile]);
                                    tempDrivePath[strlen(tempDrivePath)-4] = 0;
                                    strcat(tempDrivePath,".FSS");
                                    SaveSnapshot(tempDrivePath);
                                    showMenu = 0;
                                }
                                break;
                            case 1: // Controls
                                if(menuItem == 0){
                                    current_joystick = 1-current_joystick;
                                }
                                if(menuItem >=1 && menuItem <=3){
                                    ThePrefs.keyButton[menuItem-1]++;
                                    if(ThePrefs.keyButton[menuItem-1] > 69){ThePrefs.keyButton[menuItem-1]=0;}
                                }

                            break;                                
                            case 2: // Screen
                                if(menuItem <=3){
                                    ThePrefs.Zoom = menuItem;
                                }
                                if(menuItem==4){
                                    ThePrefs.Scale = !ThePrefs.Scale;
                                    memset(gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL),0,400*240*3);
                                    gfxSwapBuffers();
                                    memset(gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL),0,400*240*3);
                                }
                                
                                
                            break;                                
                            case 3: // Misc
                            break;                                
                            case 4: // About
                            break;                                
                        }
                        break;
                }// switch menuNum
                
                
                
            } // A pressed
        }
    
        if( keys & KEY_B ){
            if(!(oldKeys & KEY_B)){
                if(menuNum>0 && filesGot==0){menuNum--;}
                if(filesGot==1){filesGot=0;}
            }
        }

        if(menuNum==1 && filesGot==0){
            if( keys & KEY_R ){
                if(!(oldKeys & KEY_R)){
                    if(settingsMenu<3){settingsMenu++; menuItem=0;}
                }
            }
            if( keys & KEY_L ){
                if(!(oldKeys & KEY_L)){
                    if(settingsMenu>0){settingsMenu--; menuItem=0;}
                }
            }
        } // menu item 1
        
    
    }// show menu

    if( keys & KEY_START ){
        if(!(oldKeys & KEY_START)){
            if(showMenu == 0){
                Pause(); // pause the C64
                showMenu = 1;//-showMenu;
                menuNum = 0;
                menuItem=0;
                TheDisplay->Update(1);
            }
        }
    }

    
if(filesGot==0){
    if(keys & KEY_L ){
        FForward = 1;
        ThePrefs.SkipFrames = 100;
    }else{
        FForward = 0;
        ThePrefs.SkipFrames = FrameSkip;
    }
    
    
}
    
    if(resetLoad==true){
        menuIsOn=0;
        showMenu=0;
        redrawMenu=0;
        if(resetLoadTimer <= svcGetSystemTick()){
            resetLoad=false;
            resetLoadTimer=0;
            // set current disk
            Prefs *prefs = new Prefs(ThePrefs);
            strcpy(prefs->DrivePath[0], filelist[currentFile]);
            this->NewPrefs(prefs);
            ThePrefs = *prefs;
            delete prefs;
            // load first prg
            
            // if.prg, load directly
            if(fileType[currentFile] == 2){
                struct stat st;
                stat(filelist[currentFile], &st);
                int size = st.st_size;
                uint8* buffer= (uint8 *)malloc(size);
                FILE *filepointer = fopen(filelist[currentFile], "rb");
                fread(buffer,size,1,filepointer);
                fclose(filepointer);
                load_prg(this, buffer, size);
                free(buffer);
            }            
            
            
            kbd_buf_feed(resetLoadString);
        }
    }
    
    
    
    
    oldKeys = keys;
    //sprintf(debugText, "Path:  %s ", currentPath);
    
    
    
}


/*
 *  Vertical blank: Poll keyboard and joysticks, update window
 */
 
int old_time;
void C64::VBlank(bool draw_frame)
{
    fps++;
	poll_input();
	kbd_buf_update(this);

	TheDisplay->PollKeyboard(TheCIA1->KeyMatrix, TheCIA1->RevMatrix, &joykey);

	TheCIA1->Joystick1 = poll_joystick(0);
	TheCIA1->Joystick2 = poll_joystick(1);
/*
    if(theFPS == 48 || theFPS == 49){
        if(fps%25 == 0){
            draw_frame=0;
        }else{
            draw_frame=1;
        }
    }
*/
    
    // attempt to drop frames
//    int DropFrames = 3;
//    int q = 50/DropFrames; + (50 % DropFrames != 0);
//    if(fps % q == 0){draw_frame=0;}else{draw_frame=1;}
    
	if(draw_frame) { 
		TheDisplay->Update(0);
	}
    // limit speed unless FForward
    
        u64 tim2 = svcGetSystemTick();
        while(tim2 < tim && abs(tim2-tim) > TICKS_PER_SEC && !FForward ){tim2 = svcGetSystemTick();}
        tim = svcGetSystemTick() + (TICKS_PER_SEC/50);
}


/*
 *  Open/close joystick drivers given old and new state of
 *  joystick preferences
 */ 
extern char* dotextmenu();
void C64::open_close_joysticks(int oldjoy1, int oldjoy2, int newjoy1, int newjoy2)
{
}
 



/*
 *  Poll joystick port, return CIA mask 
 */
int space=0;
int switchstick=0;

int mouseX=0;
int oldMouseX=0;

uint8 C64::poll_joystick(int port)
{
    uint8 j = 0xff;
	if(port!=current_joystick) return j;
	//hidScanInput();
	u32 keys = hidKeysHeld();
    if( keys & KEY_LEFT  ) j&=0xfb;
    if( keys & KEY_RIGHT ) j&=0xf7;
    if( keys & KEY_UP    ) j&=0xfe;
    if( keys & KEY_DOWN  ) j&=0xfd;
    if( keys & KEY_A     ) j&=0xef;

    // hack to add different joystick buttons to inputs...
    int joyButts[4]={0xfe,0xfd,0xfb,0xf7};

    if(keys & KEY_X){
        if(ThePrefs.keyButton[0] >= 66){
            j&=joyButts[ThePrefs.keyButton[0]-66];
        }
    }
    if(keys & KEY_Y){
        if(ThePrefs.keyButton[1] >= 66){
            j&=joyButts[ThePrefs.keyButton[1]-66];
        }
    }
    if(keys & KEY_B){
        if(ThePrefs.keyButton[2] >= 66){
            j&=joyButts[ThePrefs.keyButton[2]-66];
        }
    }
    
    
    
    
    
	return j;
}


/*
 * The emulation's main loop
 */

/*
// Apparently this will wake the app from sleep...
*/

void C64::system_checkPolls() {

// warning, drops about 5 fps!
    APT_AppStatus status;

	while((status=aptGetStatus()) != APP_RUNNING) {
        // Close Lid
        if(status == APP_PREPARE_SLEEPMODE)
        {
            Pause();
			aptSignalReadyForSleep();
            aptWaitStatusEvent();
            Resume();
        }
        // Home Button
        if(status == APP_SUSPENDING)
        {
            Pause();
            aptReturnToMenu();
            Resume();
        }
        
        if(aptGetStatus() == APP_EXITING)
        {

            Pause(); // exit audio safely..
            // Save Prefs
            Prefs *prefs = new Prefs(ThePrefs);
            prefs->Save("/c64/prefs.ini");
            delete prefs;
            // Save Snapshot
            SaveSnapshot("/c64/continue.fss");
            
            //free(bufmem);
            //free(screenBuffer);
            quit_thyself=1;
            break;
        }

    }
}

void C64::thread_func(void)
{
//consolePrintf("\tthread_func\n");

	int linecnt = 0;

#ifdef FRODO_SC
	while (!quit_thyself) {

		// The order of calls is important here
		if (TheVIC->EmulateCycle())
			TheSID->EmulateLine();
		TheCIA1->CheckIRQs();
		TheCIA2->CheckIRQs();
		TheCIA1->EmulateCycle();
		TheCIA2->EmulateCycle();
		TheCPU->EmulateCycle();

		if (ThePrefs.Emul1541Proc) {
			TheCPU1541->CountVIATimers(1);
			if (!TheCPU1541->Idle)
				TheCPU1541->EmulateCycle();
		}
		CycleCounter++;
#else
	while (!quit_thyself) {
        //FPS Counter
		if (svcGetSystemTick() >= tickOld + TICKS_PER_SEC){
            system_checkPolls(); //  do sleep mode stuff
			tickOld = svcGetSystemTick();
            theFPS = fps;
			fps = 0;
            soundCheck=1;
            Seconds++;
            if(Seconds >=ThePrefs.SleepTimeOut && ThePrefs.SleepTimeOut > 0){
                screenDark = 1;
                
            }
        }        
/*        
        APP_STATUS status;
        status=aptGetStatus();
        if(status == APP_SLEEPMODE){
            aptWaitStatusEvent();
        }
  */      
        
		if(pauseSystem)
        {
			poll_input();
//			consolePrintf("&");
			//TheDisplay->BufSwap();
            TheDisplay->Update(0);
			continue; 
		}

		// The order of calls is important here
		int cycles = TheVIC->EmulateLine();
		TheSID->EmulateLine();
#if !PRECISE_CIA_CYCLES
		TheCIA1->EmulateLine(ThePrefs.CIACycles);
		TheCIA2->EmulateLine(ThePrefs.CIACycles);
#endif 

		if (ThePrefs.Emul1541Proc) {
			int cycles_1541 = ThePrefs.FloppyCycles;
			TheCPU1541->CountVIATimers(cycles_1541);

			if (!TheCPU1541->Idle) {
				// 1541 processor active, alternately execute
				//  6502 and 6510 instructions until both have
				//  used up their cycles
				while (cycles >= 0 || cycles_1541 >= 0)
					if (cycles > cycles_1541)
						cycles -= TheCPU->EmulateLine(1);
					else
						cycles_1541 -= TheCPU1541->EmulateLine(1);
			} else
				TheCPU->EmulateLine(cycles);
		} else
			// 1541 processor disabled, only emulate 6510
			TheCPU->EmulateLine(cycles);
#endif
		linecnt++;
	}
        
        // close lid stuff (I hope!)
        
}

void C64::Pause() {
	pauseSystem=true;
	TheSID->PauseSound();
}

void C64::Resume() {
    if(pauseSystem==true){
	   pauseSystem=false;
	   TheSID->ResumeSound();
    }
}
