// scroller from http://tnd64.unikat.sk/assemble_it6.html


#define CONFIG_3D_SLIDERSTATE (*(float*)0x1FF81080)

#define RGB565(r,g,b)  (((b)&0x1f)|(((g)&0x3f)<<5)|(((r)&0x1f)<<11))
#define RGB8_to_565(r,g,b)  (((b)>>3)&0x1f)|((((g)>>2)&0x3f)<<5)|((((r)>>3)&0x1f)<<11)

#ifndef REG_LCDBACKLIGHTSUB
#define REG_LCDBACKLIGHTSUB (u32)(0x1ED02A40 - 0x1EB00000)
#endif

#include "SAM.h"
#include "C64.h" 
#include "VIC.h" 
#include "file.h"
#include "main.h"

#include"settings_maps.h"

#include "myfont_bin.h"
#include "myfont1_bin.h"
#include "charset_bin.h"

//#include "splash_bin.h"

int rainbow[9]={14,10,15,7,1,7,15,10,14};
// menus offset
bool redrawMenu = 0;
int Top = 35;//25;
int Left = 32;

static u32 brightnessSub;
int isPaused;
int musicMaker=0;
int menuIsOn=0;

int c64_key=-1;
int lastc64key=-1;
int keyHeld = -1;
int oldKeyHeld = -1;

int drawingKeyboard=0;

int oldKeyTouch;
uint32 keyTouch;

int hb_count=0;
//int theFPS;
int colours[16];

void printdbg(char *s);
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h> 
#include <sys/dir.h> 
#include <unistd.h>


//Menu stuff
char menuItems[4][20][40]; // 5 sub menus, upto 20 items, upto 40 characters
char subMenuTitles[5][20];
char filetypes[5][4];

#define MOVE_MAX 16

//#define PEN_DOWN (~IPC->buttons & (1 << 6))
#define X_KEY (~IPC->buttons & (1 << 0))
#define Y_KEY (~IPC->buttons & (1 << 1))

#define ABS(a) (((a) < 0) ? -(a) : (a))
#define	ROUND(f) ((u32) ((f) < 0.0 ? (f) - 0.5 : (f) + 0.5))

void drawKeyboard(void);
void drawKey(int x, int y, int size, int character, bool pressed);


uint8 *bufmem;
uint8 *screenBuffer;

int emu_buf=0;
bool shifted = 0; // shift keys
bool shiftLock = 0; // shift lock key
bool cmbed = 0;
bool ctrled = 0;
int bytesPerRow = 400;
int oldTouch=0;
int fileBG = 0;
//int showMenu=0;

static int keystate[256];

char str[100];
int menufirsttime =0;
int choosingfile = 1;
char* dotextmenu()
{
    return 0;
}
void WaitForVblank();

void drawPixel(int x, int y, char r, char g, char b, u8* screen)
{
	int height=240;
    u32 v=((239-y)+x*height)*3;
	screen[v]=b;
	screen[v+1]=g;
	screen[v+2]=r;
}

void Plot(int x, int y, char r, char g, char b, u8* screen)
{
    int sWidth = 400;
    if(x>=0 && x<sWidth && y>=0 && y<240){
        int height=240;
        u32 v=((239-y)+x*height)*3;
        screen[v]=b;
        screen[v+1]=g;
        screen[v+2]=r;
    }
}

void drawRect(int x, int y, int width, int height, int r, int g, int b){
    for(int y1=y; y1<y+height; y1++){
        for(int x1=x; x1<x+width; x1++){
            Plot(x1,y1,r,g,b,screenBuffer);
        }
    }
    
}

void plotC64(int x, int y, int col, bool screen){
    int wide = bytesPerRow;

    if(screen == 0){ // top screen = draw to c64 buffer!
        bufmem[x+wide*y] = col;

    }
    
    if(screen == 1){
        int br,bg,bb;
        int fr = colours[col] >> 16;
        int fg = (colours[col] >> 8) & 255;
        int fb = colours[col] & 255;

        // cheat for some reason drawing key glyphs the wrong colour on first draw.
        if(col==1){
           fr=255; fg=255; fb=255;
        }
        
        
        u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    	int height=240;
        u32 v=((239-y)+x*height)*3;
        bufAdr[v]=fb;
        bufAdr[v+1]=fg;
        bufAdr[v+2]=fr;
    }

}

// draw charcter from charMap[]
void drawChar(int x, int y, int ch, u8* screen, int fcol, int bcol=-1){
    
    
    bool useScreen = 0;
    u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    if(bufAdr == screen){useScreen = 1;}
    
    int br,bg,bb;
    int fr = colours[fcol] >> 16;
    int fg = (colours[fcol] >> 8) & 255;
    int fb = colours[fcol] & 255;

    
    if(bcol != -1){
        br = colours[bcol] >> 16;
        bg = (colours[bcol] >> 8) & 255;
        bb = colours[bcol] & 255;
    }
    for(int y1=0; y1<8; y1++){
        for(int x1=0; x1<8; x1++){
            int p = charset_bin[(charMap[ch]*64)+(x1+8*y1)];
            if(p==1){
                plotC64(x+x1,y+y1,fcol,useScreen);
//                Plot(x+x1,y+y1,fr,fg,fb,screen);
            }else{
                if(bcol != -1){
                    plotC64(x+x1,y+y1,bcol,useScreen);
//                    Plot(x+x1,y+y1,br,bg,bb,screen);
                }
            }
        }
    }
}


void drawPetChar(int x, int y, int ch, u8* screen, int fcol, int bcol=-1){
    bool useScreen = 0;
    u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    if(bufAdr == screen){useScreen = 1;}
    
    for(int y1=0; y1<8; y1++){
        for(int x1=0; x1<8; x1++){
            int p = myfont1_bin[((ch)*64)+(x1+8*y1)];
            if(p==0){
                plotC64(x+x1,y+y1,fcol,useScreen);
            }else{
                if(bcol != -1){
                    plotC64(x+x1,y+y1,bcol,useScreen);
                }
            }
        }
    }
}




void drawText(int x, int y, int mx, int my, const char* string, int color, int fNum, bool center, bool screen=1, u8* scrn=NULL)
{
	int x1=0, y1=0;
    u16 temp = 0;
	int line_width = 0;
	int karakta = 0;

    u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    
    if(screen==0){
        bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    }

    if(scrn != NULL){
        bufAdr=scrn;
    }
    
	for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp]-32;
	   line_width += 8;//fontWidth[karakta];
	}
	if(center)x = ((mx+x)>>1) -(line_width>>1);
	line_width=0;
	int alpha=0;

    for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp]-32;
		//if(fNum==0)wide = fontWidth[karakta];
		//if(fNum==1)wide = font1Width[karakta];
	   for(y1=0; y1<16; y1++){
			for(x1=0; x1<16; x1++){
				if(fNum==0)alpha = myfont_bin[(karakta*16*16) + x1 + 16 * y1];
				if(fNum==1)alpha = myfont_bin[(karakta*16*16) + x1 + 16 * y1];
				if(alpha>>3 <31){ // skip plotting if no alpha
                    plotC64(x1+line_width+x,y+y1,color,screen);
                }// alpha			
			}   
		}
		if(fNum==0)line_width += 8;//fontWidth[karakta];
		if(fNum==1)line_width += 8;//font1Width[karakta]-1;
	}      
}   





void petsciiText(int x, int y, int mx, int my, const char* string, int color, int fNum, bool center, bool screen=1, u8* scrn=NULL)
{
	int x1=0, y1=0;
    u16 temp = 0;
	int line_width = 0;
	int karakta = 0;

    u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    
    if(screen==0){
        bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    }

    if(scrn != NULL){
        bufAdr=scrn;
    }
    
	for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp];
	   line_width += 8;//fontWidth[karakta];
	}
	if(center)x = ((mx+x)>>1) -(line_width>>1);
	line_width=0;
	int alpha=0;

    for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp];
        if(karakta>=192)karakta-=96;
        for(y1=0; y1<8; y1++){
			for(x1=0; x1<8; x1++){
				alpha = myfont1_bin[(filenameCharSet[karakta]*8*8) + x1 + 8 * y1];
				if(alpha>>3 <31){ // skip plotting if no alpha
                    plotC64(x1+line_width+x,y+y1,color,screen);
                }// alpha			
			}   
		}
		line_width += 8;
	}      
}   





/*
  C64 keyboard matrix:

    Bit 7   6   5   4   3   2   1   0
  0    CUD  F5  F3  F1  F7 CLR RET DEL
  1    SHL  E   S   Z   4   A   W   3
  2     X   T   F   C   6   D   R   5
  3     V   U   H   B   8   G   Y   7
  4     N   O   K   M   0   J   I   9
  5     ,   @   :   .   -   L   P   +
  6     /   ^   =  SHR HOM  ;   *   £
  7    R/S  Q   C= SPC  2  CTL  <-  1
*/

#define MATRIX(a,b) (((a) << 3) | (b))

/*
 *  Display constructor: Draw Speedometer/LEDs in window
 */

C64Display::C64Display(C64 *the_c64) : TheC64(the_c64)
{

}


/*
 *  Display destructor
 */

C64Display::~C64Display()
{
}


/*
 *  Prefs may have changed
 */

void C64Display::NewPrefs(Prefs *prefs)
{
}

void vblankhandler()
{

}


//extern void InterruptHandler(void);

bool init_graphics(void)
{

    
for(int x=0; x<16; x++){
    for(int y=0; y<16; y++){
        bigPalRed[x+16*y] = (palette_red[x] + palette_red[y]) / 2;
        bigPalGreen[x+16*y] = (palette_green[x] + palette_green[y]) / 2;
        bigPalBlue[x+16*y] = (palette_blue[x] + palette_blue[y]) / 2;
    }
}
    
    
    gfxSetScreenFormat(GFX_TOP, GSP_BGR8_OES );
    gfxSetScreenFormat(GFX_BOTTOM, GSP_BGR8_OES );
    gfxSetDoubleBuffering(GFX_BOTTOM, false);
    gfxSetDoubleBuffering(GFX_TOP, true);
    
    bufmem = (uint8*)malloc(bytesPerRow*300*3);
    screenBuffer = gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);//(uint8*)malloc(320*240*3);
    //drawKeyboard();
    
    strcpy(subMenuTitles[0],"DISK");
    strcpy(subMenuTitles[1],"CONTROLS");
    strcpy(subMenuTitles[2],"SCREEN");
    strcpy(subMenuTitles[3],"ABOUT");
    
    // disk menu
    strcpy(menuItems[0][0],"TRUE DRIVE EMULATION");
    strcpy(menuItems[0][1],"START DISK IMAGE");
    strcpy(menuItems[0][2],"MOUNT DISK IMAGE");
    strcpy(menuItems[0][3],"LOAD SNAPSHOT");
    strcpy(menuItems[0][4],"SAVE SNAPSHOT");
    strcpy(menuItems[0][5],"SAVE AND RETURN");
    strcpy(menuItems[0][6],"EXIT TO LAUNCHER");
    // controls menu
    strcpy(menuItems[1][0],"JOYSTICK PORT");
    strcpy(menuItems[1][1],"X");
    strcpy(menuItems[1][2],"Y");
    strcpy(menuItems[1][3],"B");
    strcpy(menuItems[1][4],"SAVE AND RETURN");
    strcpy(menuItems[1][5],"EXIT TO LAUNCHER");
    // screen menu
    strcpy(menuItems[2][0],"FRAMESKIP");
    strcpy(menuItems[2][1],"     MODE");
    strcpy(menuItems[2][2],"  TIMEOUT");
    strcpy(menuItems[2][3]," KEYBOARD");
    strcpy(menuItems[2][4],"SAVE AND RETURN");
    strcpy(menuItems[2][5],"EXIT TO LAUNCHER");
    // sound menu
    strcpy(menuItems[3][0],"RESET C64");
    strcpy(menuItems[3][1],"SAMPLE RATE");
    strcpy(menuItems[3][2],"SAVE AND RETURN");
    strcpy(menuItems[3][3],"EXIT TO LAUNCHER");
    // about menu
    strcpy(menuItems[4][0],"SAVE AND RETURN");
    strcpy(menuItems[4][1],"EXIT TO LAUNCHER");
    
    
    strcpy(filetypes[0],"DEL");
    strcpy(filetypes[1],"SEQ");
    strcpy(filetypes[2],"PRG");
    strcpy(filetypes[3],"USR");
    strcpy(filetypes[4],"REL");
    //={"DEL","SEQ","PRG","USR","REL"};
    
    FrameSkip = ThePrefs.SkipFrames;
//    GSPGPU_ReadHWRegs(NULL, REG_LCDBACKLIGHTSUB, &brightnessSub, 4);

    drawKeyboard();
    
    return  bufmem;
}

int counta,firsttime;

void WaitForVblank()
{
  //  gspWaitForVBlank();
} 
 
/*
 *  Redraw bitmap
 */

void C64Pixel(int x, int y, int col, u8* screen)
{
    u32 tempPixel = ((239-y)+x*240)*3;
	screen[tempPixel] = palette_blue[col];
	screen[tempPixel+1]=palette_green[col];
	screen[tempPixel+2]=palette_red[col];
}


void C64Display::drawPixel(int x, int y, char r, char g, char b, u8* screen)
{
	int height=240;
    u32 v=((239-y)+x*height)*3;
	screen[v]=b;
	screen[v+1]=g;
	screen[v+2]=r;
}


void drawMenu(void){
    int fcol=14, bcol=6;
    u8* bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    int line[41];
    line[40]=0;
    
    for(int y=0; y<25; y++){
        bcol=6;
        for(int x=0; x<=39; x++){
            if(settingsMenu==3){
                fcol = colourMap[x+40*y];
            }else{
                fcol = 14;
            }
            //drawChar(   x*8+Left, y*8+Top, settingScreen[settingsMenu][x+40*y]-1, bufmem, fcol,bcol);
            drawPetChar(x*8+Left, y*8+Top, settingScreen[settingsMenu][x+40*y]-1, bufmem, fcol,bcol);

        }
    }
    redrawMenu=0;
}


void drawC64Screen(void){

    
/*    
    // about screen
    // bmp size = 65078 bytes
    // so skip the first 1078 bytes
    for(int y=0; y<200; y++){
        for(int x=0; x<320; x++){
            plotC64(32+x,34+(200-y),splash_bin[(x+320*y)+1078],0);
        }
    }
    
  */  
    
    u8* bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
   // int slider = -((CONFIG_3D_SLIDERSTATE)*22)+22; // scroll screen using 3d slider!
    int slider=0;
    
   // Top = -slider+35;

    
/*    
    if(ThePrefs.Zoom==0){ // scale height    
        int counter=0;
        for(int y=0; y<240; y++){
            int y1 = ((y+1)*262)/230; // 230 is a good height to keep the ratio even
            int y2 = ((y-1)*262)/230;
            int pix1 = bytesPerRow*(y1-1);
            int pix2 = bytesPerRow*(y2+1);
            for(int x=0; x<400; x++){
                int i1 = bufmem[x-8+pix1];
                int i2 = bufmem[x-8+pix2];
                int r = bigPalRed[i1+16*i2];
                int g = bigPalGreen[i1+16*i2];
                int b = bigPalBlue[i1+16*i2];
                counter = (y+240*x)*3;
                int r1 = top_frame_bin[counter++];
                int g1 = top_frame_bin[counter++];
                int b1 = top_frame_bin[counter];
                if(r1!=255 && g1!=255 && b1 != 255){
                    drawPixel(x,y,r1,g1,b1,bufAdr);
                }else{
                    drawPixel(x,y,r,g,b,bufAdr);
                }
            }
        }
    }
*/    
/*
    // Draw Border
    int counter = 0;
    for(int x=399; x>0; x--){
        for(int y=0; y<240; y++){
            int r = top_frame_bin[counter++];
            int g = top_frame_bin[counter++];
            int b = top_frame_bin[counter++];
            if(r!=255 && g!=255 && b != 255){
                drawPixel(x,y,r,g,b,bufAdr);
            }
        }
    }
*/
    
    
    
    // screen start location
    int sx = 0; int sy = 0;
    // screen end location
    int ex = 384; int ey = 240;
    // offset from top
    int ty = 0;
    // scale height
    int sh = 230; // 262 is scaled, 230 is unscaled
    
    if(ThePrefs.Zoom==1 || ThePrefs.Zoom==3){ // top/bottom borders    
        sx = 32; ex = 352;
    }
    if(ThePrefs.Zoom==2 || ThePrefs.Zoom==3){ // left/right borders    
        sy = 35; 
        ey = 235;
        if(ThePrefs.Scale){ // scale    
            sh = 262;
            ty = 0;
            sy = 30;
            ey = 206;
        }
    }
    
    if(ThePrefs.Scale){ // scale    
        sh = 262;
        ty = 0;
    }else{
        ty = 14;
    }
    
    if(sy-ty < 0){
        int temp = sy-ty;
        sy = ty;
        ey -= temp;
    }
    
    for(int y=sy; y<ey; y++){
        int y1 = ((y+1)*sh)/230; // 230 is a good height to keep the ratio even
        int y2 = ((y-1)*sh)/230;
        int pix1 = bytesPerRow*(y1-1);
        int pix2 = bytesPerRow*(y2+1);
        for(int x=sx; x<ex; x++){
            int i1 = bufmem[x+pix1];
            int i2 = bufmem[x+pix2];
            int r = bigPalRed[i1+16*i2];
            int g = bigPalGreen[i1+16*i2];
            int b = bigPalBlue[i1+16*i2];
            drawPixel(x+8,y-ty,r,g,b,bufAdr);
        }
    }

}


void drawDialog(int x, int y, int width, int height, const char* text, int screen){

    int sl = strlen(text);
    int so = (width/2)-(sl/2);
    
    u8* scr = bufmem;//gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    if(screen==1){
        scr = gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    }
    
    drawChar(x*8+Left, y*8+Top, 85, scr, 14,6);
    for(int t=0; t<width; t++){
        for(int s=0; s<height; s++){
            drawChar((x+t+1)*8+Left, (y+2+s)*8+Top, 32, scr, 14,6);
        }
        drawChar((x+t+1)*8+Left, y*8+Top, 64, scr, 14,6);
        drawChar((x+t+1)*8+Left, (y+1)*8+Top, 32, scr, 14,6);
        drawChar((x+t+1)*8+Left, (y+2)*8+Top, 64, scr, 14,6);
        drawChar((x+t+1)*8+Left, (y+2+height)*8+Top, 64, scr, 14,6);

    }
    drawChar((x+width+1)*8+Left, y*8+Top, 73, scr, 14,6);

    drawText((x+1+so)*8+Left,(y+1)*8+Top,400,16,text,14,0,0,screen,NULL);

    // |       |
    for(int t=0; t<=height; t++){
        drawChar(x*8+Left, (y+1+t)*8+Top, 66, scr, 14,6);
        drawChar((x+width+1)*8+Left, (y+1+t)*8+Top, 66, scr, 14,6);
    }
    
    // |-       -|
    drawChar(x*8+Left, (y+2)*8+Top, 107, scr, 14,6);
    drawChar((x+width+1)*8+Left, (y+2)*8+Top, 115, scr, 14,6);
    // |_       _|
    drawChar(x*8+Left, (y+2+height)*8+Top, 74, scr, 14,6);
    drawChar((x+width+1)*8+Left, (y+2+height)*8+Top, 75, scr, 14,6);

    
}


void C64Display::Update(int arg=0)
{
    
    if(arg==1){
        drawKeyboard();
    }

    
    // get screen buffer
    u8* bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    
    static int oldScreen;
    if(ThePrefs.Zoom != oldScreen){
        memset(bufAdr,0,400*240*3);
        gfxSwapBuffers();
        bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
        memset(bufAdr,0,400*240*3);
        oldScreen = ThePrefs.Zoom;
    }

    
    
    
// main menu
// If paused menu...
if(showMenu){

    int col=14;
    static int txtScreen=0;
    static int rain=0;
    if(rain++>=8*4){rain=0;}

    if(menuNum==0){ // Pause Menu
        int x=14, y=8;
        drawDialog(x,y , 10, 5, "PAUSED", 0);
        if(menuItem==0){col=rainbow[rain/4];}else{col=14;}
        drawText((x+1)*8+Left,(y+3)*8+Top,400,16,"  RETURN   ",col,0,0,  0,NULL);
        if(menuItem==1){col=rainbow[rain/4];}else{col=14;}
        drawText((x+1)*8+Left,(y+4)*8+Top,400,16," SETTINGS  ",col,0,0,  0,NULL);
        if(menuItem==2){col=rainbow[rain/4];}else{col=14;}
        drawText((x+1)*8+Left,(y+5)*8+Top,400,16,"  RESET    ",col,0,0,  0,NULL);
        if(menuItem==3){col=rainbow[rain/4];}else{col=14;}
        drawText((x+1)*8+Left,(y+6)*8+Top,400,16,"   EXIT    ",col,0,0,  0,NULL);
    }else if(menuNum==1){
        drawMenu();
        // tab text
        int titleOffsets[4]={1,7,17,34};

        for(int t=0; t<5; t++){
            if(settingsMenu == t){
                col=1;//rainbow[rain/4];
            }else{
                col=14;
            }
            drawText(titleOffsets[t]*8+Left,8+Top,400,16,subMenuTitles[t],col,0,0,  0,NULL);
        }
        
        if(settingsMenu==0){
            for(int t=0; t<7; t++){
                col = 14;
                if(t==menuItem){col=rainbow[rain/4];}
                if(t<=4){
                    drawText(16+Left,40+(t*24)+Top,400,16,menuItems[0][t],col,0,0,txtScreen,NULL);
                }
            }
            // true drive emu tick
            if(ThePrefs.Emul1541Proc == 1){
                drawChar(24*8+Left, 5*8+Top, 250, gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL), 14,6);
            }else{
                drawChar(24*8+Left, 5*8+Top, 32, gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL), 14,6);
            }
            
            
            //currentDisk
            //drawText(16+Left+(8*18),40+(1*24)+Top,400,16,currentDisk, 14,0,0,txtScreen,NULL);
            //drawText(16+Left+(8*18),40+(2*24)+Top,400,16,currentDisk, 14,0,0,txtScreen,NULL);
        } // settingmenu 0

        
        if(settingsMenu==1){
            for(int t=0; t<7; t++){
                col = 14;
                if(t==menuItem){col=rainbow[rain/4];}
                if(t<=3){
                    drawText(16+Left,40+(t*24)+Top,400,16,menuItems[settingsMenu][t],col,0,0,txtScreen,NULL);
                }
            }
                // current_joystick
                char tempString[5];
                sprintf(tempString,"%d", current_joystick+1);
                drawText((20*8)+Left,(5*8)+Top,400,16,tempString,col,0,0,txtScreen,NULL);
                
                sprintf(tempString,"%s", keyLookup[ThePrefs.keyButton[0]]);
                drawText((12*8)+Left,(8*8)+Top,400,16,tempString,col,0,0,txtScreen,NULL);
                sprintf(tempString,"%s", keyLookup[ThePrefs.keyButton[1]]);
                drawText((12*8)+Left,(11*8)+Top,400,16,tempString,col,0,0,txtScreen,NULL);
                sprintf(tempString,"%s", keyLookup[ThePrefs.keyButton[2]]);
                drawText((12*8)+Left,(14*8)+Top,400,16,tempString,col,0,0,txtScreen,NULL);
        } // settingmenu 1

        
        if(settingsMenu==2){ // screen options
            for(int t=0; t<5; t++){
                col = 14;
                if(t==menuItem){
                    col=rainbow[rain/4];

                    char width = 6;
                    char height = 5;
                    char x = 2;
                    char y = 4 + (menuItem*6);
                    
                    if(t >= 3){
                        x=21;
                        y-=18;
                    }
                    
                    drawPetChar(x*8+Left, y*8+Top, 85, bufmem, col);
                    drawPetChar(x*8+Left+(width*8), y*8+Top, 73, bufmem, col);
                    drawPetChar(x*8+Left, y*8+Top+(height*8), 74, bufmem, col);
                    drawPetChar(x*8+Left+(width*8), y*8+Top+(height*8), 75, bufmem, col);
                    
                    for(int x1=1; x1<width; x1++){
                        drawPetChar(x*8+Left+(x1*8), y*8+Top, 67, bufmem, col);
                        drawPetChar(x*8+Left+(x1*8), y*8+Top+(height*8), 67, bufmem, col);
                    }
                    for(int y1=1; y1<height; y1++){
                        drawPetChar(x*8+Left,           y*8+Top+(y1*8), 66, bufmem, col);
                        drawPetChar(x*8+Left+(width*8), y*8+Top+(y1*8), 66, bufmem, col);
                    }
                
                
                }
                
            }
        }
        
        
        
    
    } // menuNum == 1 (settings)
    
                // current_joystick
                //char tempString[5];
                //sprintf(tempString,"%d, %d, %d", settingsMenu, menuNum, menuItem);
                //drawText((1*8)+Left,(3*8)+Top,400,16,tempString,col,0,0,txtScreen,NULL);
    
    
    
    
    
    
if (filesGot == 1){

        bufAdr = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
        int fcol=14, bcol=6;
        for(int y=0; y<22; y++){
            bcol=6;
            for(int x=0; x<30; x++){
                drawChar((x+1)*8+Left, Top+(y+2)*8, FileDialog[x+30*y]-1, bufAdr, fcol,bcol);
            }
        }
//    }
  
    int listX = (2*8)+Left;
    if(fileTypes==0){
        if(mountOnly==0){
            drawText(listX,Top+24,37*8,16,"Load Disk Image",14,0,0,txtScreen,NULL);
        }else{
            drawText(listX,Top+24,37*8,16,"Mount Disk Image",14,0,0,txtScreen,NULL);
        }
    }
    if(fileTypes==1){
        drawText(listX+Left,Top+24,37*8,16,"Load Save State",14,0,0,txtScreen,NULL);
    }
    
    
    int start = currentFile - 18;
    int end = currentFile + 18;
    if(end>filesInList)end=filesInList;
    start = end - 18;
    if(start<0)start=0;
    
    static int rain=0;
    if(rain++>=8*4){rain=0;}
    for(int t=start; t<end; t++){
        int col = 14;
        if(fileType[t]==4){col=1;}
        if(t==currentFile){
            col=rainbow[rain/4];
        }// current file
        if(fileType[t]==4){ // Folder
            char tempText[50];
            int len = strlen(filelist[t])-1;
            char tempString[255];
            strcpy(tempString, filelist[t]);
            tempString[len]=0;
            sprintf(tempText,"[%s]", tempString);
            drawText(listX,Top+40+(8*t)-(start*8),37*8,16,tempText,col,0,0,txtScreen,NULL);
        }else{
            drawText(listX,Top+40+(8*t)-(start*8),37*8,16,filelist[t],col,0,0,txtScreen,NULL);
        }
    }

    
    //drawText(14,210,400,16,"(A) AutoLoad, (Y) Mount,",1,0,0,txtScreen,NULL);
    //drawText(14,218,400,16,"(X) Mount and LIST, (B) Cancel ",1,0,0,txtScreen,NULL);
    //gspWaitForVBlank();
}
    
    

}    
    

    
if (gotprogs == 1){
    static int rain=0;
    if(rain++>=8*4){rain=0;}
    int listX = (2*8)+Left;
    
    bufAdr = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    int fcol=14, bcol=6;
    for(int y=0; y<22; y++){
        bcol=6;
        for(int x=0; x<30; x++){
            drawChar((x+1)*8+Left, Top+16+y*8, FileDialog[x+30*y]-1, bufAdr, fcol,bcol);
        }
    }
    
    
    int listOffset = 0;
    if(currentProg >= 16){
        listOffset = currentProg - 16;
    }
    
    int col = 14;
    // display disk contents
    //drawText(listX , Top+24,319,16,diskname, 1 ,0,0, 0,NULL);
    petsciiText(listX+(8*5),Top+24,319,16,diskname, 1 ,0,0, 0,NULL);
    
    int maxList = numprogs;
    if(maxList >= 17) maxList=17;
    
    for(int i=0; i<maxList; i++){
        if(i+listOffset == currentProg){col = rainbow[rain/4];}else{col = 14;}
        if(progTypes[i+listOffset]!=0){
            char tempText[10];
            sprintf(tempText,"%d", progsize[i+listOffset]);
            petsciiText(listX,Top+40+(8*i),319,16,tempText, col ,0,0, 0,NULL);
            petsciiText(listX+(8*5),Top+40+(8*i),319,16,progNames[i+listOffset], col ,0,0, 0,NULL);
            petsciiText(listX+(8*22),Top+40+(8*i),319,16,filetypes[progTypes[i+listOffset]&3], col ,0,0, 0,NULL);
        }
    }
    //char tempText[50];
    //sprintf(tempText,"PROGRAMS = %d ", numprogs);
    //drawText(8,(8*numprogs)+16,319,16, tempText, col ,0,0, txtScreen,NULL);
    //petsciiText(listX+160,Top+24,319,16,tempText, 1 ,0,0, 0,NULL);
    
}
    
    
//    char str[4];
//    sprintf(str, "%d FPS", theFPS);
//    petsciiText(32,27,319,16,str, 1 ,0,0, 0,NULL);
    
    
    
    //if(!showMenu){
        drawC64Screen();
    //}
    
    
    
	gfxSwapBuffers();
}





// Bunch of stuff for displaying text (i hope)





int C64Display::mix(int back, int front, int alpha)
{
	if(alpha<8){
		return front;
	}else{
		return back+(((front-back)*(255-alpha))>>8);	
	}
}   

// mix two numbers together
//#define mix(back, front, alpha) back+(((front-back)*(255-alpha))>>8)

void C64Display::drawText(int x, int y, int mx, int my, const char* string, int color, int fNum, bool center, bool screen=1, u8* scrn=NULL)
{
	int x1=0, y1=0;
    u16 temp = 0;
	int line_width = 0;
	int karakta = 0;

    u8* bufAdr=gfxGetFramebuffer(GFX_BOTTOM, GFX_LEFT, NULL, NULL);
    if(screen==0){
        bufAdr=gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
    }

    if(scrn != NULL){
        bufAdr=scrn;
    }
    
	for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp]-32;
	   line_width += 8;//fontWidth[karakta];
	}
	if(center)x = ((mx+x)>>1) -(line_width>>1);
	line_width=0;
	int alpha=0;
  	int height=240;

    for(temp=0; temp<strlen(string); temp++){
	   karakta = string[temp]-32;
	   for(y1=0; y1<16; y1++){
			for(x1=0; x1<16; x1++){
				if(fNum==0)alpha = myfont_bin[(karakta*16*16) + x1 + 16 * y1];
				if(fNum==1)alpha = myfont_bin[(karakta*16*16) + x1 + 16 * y1];
                //drawPixel(x1+line_width+x,y+y1,0,0,0,bufAdr);
				if(alpha>>3 <31){ // skip plotting if no alpha
                    plotC64(x1+line_width+x,y+y1,color,screen);
				}// alpha			
			}   
		}
		if(fNum==0)line_width += 8;//fontWidth[karakta];
		if(fNum==1)line_width += 8;//font1Width[karakta]-1;
	}      
}   










void C64Display::BufSwap(void)
{
}

void C64Display::Speedometer(int speed)
{
}


/*
 *  Return pointer to bitmap data
 */

uint8 *C64Display::BitmapBase(void)
{
	return (uint8 *)bufmem;
}
	




/*
 *  Return number of bytes per row
 */

int C64Display::BitmapXMod(void)
{
	return bytesPerRow;
}

void C64Display::KeyPress(int key, uint8 *key_matrix, uint8 *rev_matrix) {
	int c64_byte, c64_bit, shifted;
	if(!keystate[key]) {
		keystate[key]=1;
		c64_byte=key>>3;
		c64_bit=key&7;
		shifted=key&128;
		c64_byte&=7;
		if(shifted) {
			key_matrix[6] &= 0xef;
			rev_matrix[4] &= 0xbf;
		}
        
        if(ctrled){
			key_matrix[7] &= ~(1 << 2);
			rev_matrix[2] &= ~(1 << 7);
        }
        
        
        if(cmbed){
			key_matrix[7] &= ~(1 << 5);
			rev_matrix[5] &= ~(1 << 7);
        }

        
		key_matrix[c64_byte]&=~(1<<c64_bit);
		rev_matrix[c64_bit]&=~(1<<c64_byte);
	}
}

void C64Display::KeyRelease(int key, uint8 *key_matrix, uint8 *rev_matrix) {
	int c64_byte, c64_bit, shifted;
	if(keystate[key]) {
		keystate[key]=0;
		c64_byte=key>>3;
		c64_bit=key&7;
		shifted=key&128;
		c64_byte&=7;
		if(shifted) {
			key_matrix[6] |= 0x10;
			rev_matrix[4] |= 0x40;
            shifted = 0;
		}
		key_matrix[c64_byte]|=(1<<c64_bit);
		rev_matrix[c64_bit]|=(1<<c64_byte);
	}
}

void line(int x0, int y0, int x1, int y1, int r, int g, int b) {
 
  int dx = abs(x1-x0), sx = x0<x1 ? 1 : -1;
  int dy = abs(y1-y0), sy = y0<y1 ? 1 : -1; 
  int err = (dx>dy ? dx : -dy)/2, e2;
 
  for(;;){
    Plot(x0,y0,r,g,b, screenBuffer);
    if (x0==x1 && y0==y1) break;
    e2 = err;
    if (e2 >-dx) { err -= dy; x0 += sx; }
    if (e2 < dy) { err += dx; y0 += sy; }
  }
}
void drawKey(int x, int y, int size, int character, bool pressed=0){

    switch(character){
        case 0: { size = 1; y = 152;  x = 16; break;}
        case 1: { size = 1; y = 152;  x = 32; break;}
        case 2: { size = 1; y = 152;  x = 48; break;}
        case 3: { size = 1; y = 152;  x = 64; break;}
        case 4: { size = 1; y = 152;  x = 80; break;}
        case 5: { size = 1; y = 152;  x = 96; break;}
        case 6: { size = 1; y = 152;  x = 112; break;}
        case 7: { size = 1; y = 152;  x = 128; break;}
        case 8: { size = 1; y = 152;  x = 144; break;}
        case 9: { size = 1; y = 152;  x = 160; break;}
        case 10:{ size = 1; y = 152;  x = 176; break;}
        case 11:{ size = 1; y = 152;  x = 192; break;}
        case 12:{ size = 1; y = 152;  x = 208; break;}
        case 13:{ size = 1; y = 152;  x = 224; break;}
        case 14:{ size = 1; y = 152;  x = 240; break;}
        case 15:{ size = 1; y = 152;  x = 256; break;}

        case 16:{ size = 2; y = 168;  x = 16; break;}
        case 17:{ size = 1; y = 168;  x = 32+8; break;}
        case 18:{ size = 1; y = 168;  x = 48+8; break;}
        case 19:{ size = 1; y = 168;  x = 64+8; break;}
        case 20:{ size = 1; y = 168;  x = 80+8; break;}
        case 21:{ size = 1; y = 168;  x = 96+8; break;}
        case 22:{ size = 1; y = 168;  x = 112+8; break;}
        case 23:{ size = 1; y = 168;  x = 128+8; break;}
        case 24:{ size = 1; y = 168;  x = 144+8; break;}
        case 25:{ size = 1; y = 168;  x = 160+8; break;}
        case 26:{ size = 1; y = 168;  x = 176+8; break;}
        case 27:{ size = 1; y = 168;  x = 192+8; break;}
        case 28:{ size = 1; y = 168;  x = 208+8; break;}
        case 29:{ size = 1; y = 168;  x = 224+8; break;}
        case 30:{ size = 2; y = 168;  x = 240+8; break;}

        case 31:{ size = 1; y = 184;  x = 16; break;}
        case 32:{ size = 1; y = 184;  x = 32; break;}
        case 33:{ size = 1; y = 184;  x = 48; break;}
        case 34:{ size = 1; y = 184;  x = 64; break;}
        case 35:{ size = 1; y = 184;  x = 80; break;}
        case 36:{ size = 1; y = 184;  x = 96; break;}
        case 37:{ size = 1; y = 184;  x = 112; break;}
        case 38:{ size = 1; y = 184;  x = 128; break;}
        case 39:{ size = 1; y = 184;  x = 144; break;}
        case 40:{ size = 1; y = 184;  x = 160; break;}
        case 41:{ size = 1; y = 184;  x = 176; break;}
        case 42:{ size = 1; y = 184;  x = 192; break;}
        case 43:{ size = 1; y = 184;  x = 208; break;}
        case 44:{ size = 1; y = 184;  x = 224; break;}
        case 45:{ size = 3; y = 184;  x = 240; break;}
            
        case 46:{ size = 1; y = 200;  x = 16; break;}
        case 47:{ size = 2; y = 200;  x = 32; break;}
        case 48:{ size = 1; y = 200;  x = 48+8; break;}
        case 49:{ size = 1; y = 200;  x = 64+8; break;}
        case 50:{ size = 1; y = 200;  x = 80+8; break;}
        case 51:{ size = 1; y = 200;  x = 96+8; break;}
        case 52:{ size = 1; y = 200;  x = 112+8; break;}
        case 53:{ size = 1; y = 200;  x = 128+8; break;}
        case 54:{ size = 1; y = 200;  x = 144+8; break;}
        case 55:{ size = 1; y = 200;  x = 160+8; break;}
        case 56:{ size = 1; y = 200;  x = 176+8; break;}
        case 57:{ size = 1; y = 200;  x = 192+8; break;}
        case 58:{ size = 2; y = 200;  x = 208+8; break;}
        case 59:{ size = 1; y = 200;  x = 224+16; break;}
        case 60:{ size = 1; y = 200;  x = 240+16; break;}
        case 61:{ size = 4; y = 216;  x = 64; break;}
        case 62:{ size = 2; y = 152;  x = 280; break;}
        case 63:{ size = 2; y = 168;  x = 280; break;}
        case 64:{ size = 2; y = 184;  x = 280; break;}
        case 65:{ size = 2; y = 200;  x = 280; break;}
        
        default:{ size = 0; y = 0;  x = 320; break;}
            
    }
    
    int kr = 67; int kg = 38; int kb = 7;
    int hr = 101; int hg = 56; int hb = 6;
    int sr = 38; int sg = 18; int sb = 2;
    int br = 15; int bg = 7; int bb = 1;
    
    if(character >= 62 && character <= 65){ // F Keys
        kr = 118; kg = 120; kb = 114;
        hr = 137; hg = 138; hb = 136;
        sr = 78; sg = 83; sb = 70;
    }

    if(pressed){
        kr = 154; kg = 103; kb = 89;
        hr = 170; hg = 118; hb = 106;
        sr = 134; sg = 89; sb = 78;
    }
    
    int width=15;
    if(size==1){width=15;}
    if(size==2){width=23;}
    if(size==3){width=31;}
    if(size==4){width=143;}
    // base colour
    drawRect(x,y,  width, 15,  kr ,kg ,kb);
    // highlight
    line(x+2,y,x+width-3,y,hr,hg,hb);
    line(x,y+2,x,y+12,hr,hg,hb);
    // shaddow
    line(x+2,y+14,x+width-3,y+14,sr,sg,sb);
    line(x+width-1,y+2,x+width-1,y+12,sr,sg,sb);
    // border
    line(x-1,y-1,x+width,y-1,  br,bg,bb);
    line(x-1,y+15,x+width,y+15,  br,bg,bb);
    line(x-1,y-1,x-1,y+15,  br,bg,bb);
    line(x+width,y-1,x+width,y+15,  br,bg,bb);
    Plot(x,y,br,bg,bb,screenBuffer);
    Plot(x+width-1,y,br,bg,bb,screenBuffer);
    Plot(x+width-1,y+14,br,bg,bb,screenBuffer);
    Plot(x,y+14,br,bg,bb,screenBuffer);

// now the glyphs
    int x1,y1=0;
    switch( character){
        // clr/home
        case 14:{ x1=x+1; y1=y+1; for(int y=0; y<13; y++){ for(int x=0; x<13; x++){ if(glyph1[x+13*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // inst/del -2
        case 15:{ x1=x+1; y1=y+1; for(int y=0; y<13; y++){ for(int x=0; x<13; x++){ if(glyph2[x+13*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // CTRL -3
        case 16:{ x1=x+3; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<17; x++){ if(glyph3[x+17*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // RESTORE -4
        case 30:{ x1=x+3; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<17; x++){ if(glyph4[x+17*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // run/stop -5
        case 31:{ x1=x+1; y1=y+1; for(int y=0; y<13; y++){ for(int x=0; x<13; x++){ if(glyph5[x+13*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // shift lock -6
        case 32:{ x1=x+1; y1=y+1; for(int y=0; y<13; y++){ for(int x=0; x<13; x++){ if(glyph6[x+13*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // RETURN -7
        case 45:{ x1=x+3; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<25; x++){ if(glyph7[x+25*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // C= -8
        case 46:{ x1=x+3; y1=y+3; for(int y=0; y<10; y++){ for(int x=0; x<13; x++){ if(glyph8[x+13*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // Left Shift -9
        case 47:{ x1=x+2; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<18; x++){ if(glyph9[x+18*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // Right Shift -10
        case 58:{ x1=x+2; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<18; x++){ if(glyph9[x+18*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // Cursors -11, -12
        case 59:{ x1=x+2; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<15; x++){ if(glyph10[x+25*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // Cursors -11, -12
        case 60:{ x1=x-3; y1=y+4; for(int y=0; y<7; y++){ for(int x=0; x<15; x++){ if(glyph10[(x+10)+25*y]==1){ Plot(x+x1,y+y1,255,255,255,screenBuffer); } } } break; }
        // Space
        case 61:{ break; }
        // F Keys
        case 62:{
            drawChar(x+3, y+4, 6, screenBuffer,1,-1);
            drawChar(x+11, y+4, 49+shifted, screenBuffer,1,-1);
            break;
        }
        case 63:{
            drawChar(x+3, y+4, 6, screenBuffer,1,-1);
            drawChar(x+11, y+4, 51+shifted, screenBuffer,1,-1);
            break;
        }
        case 64:{
            drawChar(x+3, y+4, 6, screenBuffer,1,-1);
            drawChar(x+11, y+4, 53+shifted, screenBuffer,1,-1);
            break;
        }
        case 65:{
            drawChar(x+3, y+4, 6, screenBuffer,1,-1);
            drawChar(x+11, y+4, 55+shifted, screenBuffer,1,-1);
            break;
        }
        default:{ 
            if(shifted){
                //drawChar(int x, int y, int ch, u8* screen, int fcol=14, int bcol=-1)
                drawChar(x+3, y+4, keysMapShift[character]-1, screenBuffer,1,-1);
            }else if(cmbed){
                int temp = character;
                if(temp >=1 && temp <=8){
                    drawPetChar(x+3, y+4, 224, screenBuffer, temp+7, -1);
                }else{
                    drawChar(x+3, y+4, keysMapCmb[character]-1, screenBuffer,1,-1);
                }
            }else if(ctrled){
                int temp = character;
                if(temp >=1 && temp <=8){
                    drawPetChar(x+3, y+4, 224, screenBuffer, temp-1, -1);
                }else{
                    drawChar(x+3, y+4, 32, screenBuffer,1,-1);
                }
            }else{
                drawChar(x+3, y+4, keysMap[character]-1, screenBuffer,1,-1); 
            }
            break;
        }
    } // switch
};


void drawKeyboard(void){
    
    drawingKeyboard=1;
    
    if((showMenu == 1 && menuIsOn == 0) || filesGot == 1 || redrawMenu){
        menuIsOn=1;
        //u8* bufAdr = screenBuffer;
    }else{
    
    // draw keyboard if not settings screen
    drawRect(0,0,  320, 120,  0,120,215);
    // draw keyboard
    drawRect(0,120,  320, 120,  172,157,128);
    line(0,120,319,120, 78,71,58);
    for(int t=0; t<5; t++){
        line(0,128+(t*3),319,128+(t*3), 144,126,96);
        line(0,129+(t*3),319,129+(t*3), 196,184,164);
    }
    // a key
    for(int t=1; t<66; t++){
        drawKey(0,0,1,t);
    }

    drawKey(65,217,4,0); // space

    if(musicMaker==1){
        drawRect(41,145,222,39, 255,255,255);
        line(40,145, 40,184, 0,0,0);
        line(40,184, 263,184, 0,0,0);
        line(263,145, 263,184, 0,0,0);
        // black keys
        int x1=0;
        x1=50; drawRect(x1,145,8,23, 0,0,0);
        x1=66; drawRect(x1,145,8,23, 0,0,0);

        x1=98; drawRect(x1,145,8,23, 0,0,0);
        x1=114; drawRect(x1,145,8,23, 0,0,0);
        x1=130; drawRect(x1,145,8,23, 0,0,0);
    
        x1=162; drawRect(x1,145,8,23, 0,0,0);
        x1=178; drawRect(x1,145,8,23, 0,0,0);
    
        x1=210; drawRect(x1,145,8,23, 0,0,0);
        x1=226; drawRect(x1,145,8,23, 0,0,0);
        x1=242; drawRect(x1,145,8,23, 0,0,0);
        
        for(int t=0; t<13; t++){
            line(55+(t*16),145, 55+(t*16), 184, 0,0,0);
        }
    
    }
    }

    drawingKeyboard=0;

}


/*
 *  Poll the keyboard
 */
void C64Display::PollKeyboard(uint8 *key_matrix, uint8 *rev_matrix, uint8 *joystick)
{


if((filesGot == 0 && fileBG != 0) || redrawMenu){
    drawKeyboard();
    fileBG = 0;
    menuIsOn=0;
}
    
  //  hidScanInput();
	
	uint32 keys_down = hidKeysDown();
	uint32 keys = hidKeysHeld();
	uint32 rkeys  = hidKeysUp();

    // Read touch screen
	touchPosition touch;

    //Read the touch screen coordinates
	hidTouchRead(&touch);

    
if(filesGot==0){    
    //fileBG = 0;
    c64_key = -1; // reset keys
    drawKey(0,0,1,oldKeyHeld, 0);

    if(((keys & keyTouch) && touch.py >=120 )
      || (!(keys & keyTouch) && ((keys & KEY_X) || (keys & KEY_Y) || (keys & KEY_B)))
      ){
        // do touch screen stuff here
        int penX = touch.px / 8;
        int penY = (touch.py-120) / 8; // lower half of screen
        int tile = keyboardKeys[ penX + 40 * penY ];

        if(keys & KEY_X){tile = ThePrefs.keyButton[0]+1;}
        if(keys & KEY_Y){tile = ThePrefs.keyButton[1]+1;}
        if(keys & KEY_B){tile = ThePrefs.keyButton[2]+1;}
        
        
        if(tile == 1 ) { c64_key = MATRIX(7,1); }  // <-
        if(tile == 2 ) { c64_key = MATRIX(7,0); }  // 1
        if(tile == 3 ) { c64_key = MATRIX(7,3); }  // 2
        if(tile == 4 ) { c64_key = MATRIX(1,0); }  // 3
        if(tile == 5 ) { c64_key = MATRIX(1,3); }  // 4
        if(tile == 6 ) { c64_key = MATRIX(2,0); }  // 5
        if(tile == 7 ) { c64_key = MATRIX(2,3); }  // 6
        if(tile == 8 ) { c64_key = MATRIX(3,0); }  // 7
        if(tile == 9 ) { c64_key = MATRIX(3,3); }  // 8
        if(tile == 10) { c64_key = MATRIX(4,0); }  // 9
        if(tile == 11) { c64_key = MATRIX(4,3); }  // 0
        if(tile == 12) { c64_key = MATRIX(5,0); }  // +
        if(tile == 13) { c64_key = MATRIX(5,3); }  // -
        if(tile == 14) { c64_key = MATRIX(6,0); }  // £
        if(tile == 15) { c64_key = MATRIX(6,3); }  // CLR/HOME
        if(tile == 16) { c64_key = MATRIX(0,0); }  // INST/DEL

        if(tile == 17) { c64_key = MATRIX(7,2); }  // CTRL
        if(tile == 18) { c64_key = MATRIX(7,6); }  // Q
        if(tile == 19) { c64_key = MATRIX(1,1); }  // W
        if(tile == 20) { c64_key = MATRIX(1,6); }  // E
        if(tile == 21) { c64_key = MATRIX(2,1); }  // R
        if(tile == 22) { c64_key = MATRIX(2,6); }  // T
        if(tile == 23) { c64_key = MATRIX(3,1); }  // Y
        if(tile == 24) { c64_key = MATRIX(3,6); }  // U
        if(tile == 25) { c64_key = MATRIX(4,1); }  // I
        if(tile == 26) { c64_key = MATRIX(4,6); }  // O
        if(tile == 27) { c64_key = MATRIX(5,1); }  // P
        if(tile == 28) { c64_key = MATRIX(5,6); }  // @
        if(tile == 29) { c64_key = MATRIX(6,1); }  // *
        if(tile == 30) { c64_key = MATRIX(6,6); }  // ^
        if(tile == 31) { c64_key = MATRIX(7,7); }  // Restore

        if(tile == 32) { c64_key = MATRIX(7,7); }  // Run/Stop
        if(tile == 33) { c64_key = MATRIX(1,7); shiftLock = !shiftLock; } // Shift/Lock
        if(tile == 34) { c64_key = MATRIX(1,2); }  // A
        if(tile == 35) { c64_key = MATRIX(1,5); }  // S
        if(tile == 36) { c64_key = MATRIX(2,2); }  // D
        if(tile == 37) { c64_key = MATRIX(2,5); }  // F
        if(tile == 38) { c64_key = MATRIX(3,2); }  // G
        if(tile == 39) { c64_key = MATRIX(3,5); }  // H
        if(tile == 40) { c64_key = MATRIX(4,2); }  // J
        if(tile == 41) { c64_key = MATRIX(4,5); }  // K
        if(tile == 42) { c64_key = MATRIX(5,2); }  // L
        if(tile == 43) { c64_key = MATRIX(5,5); }  // :
        if(tile == 44) { c64_key = MATRIX(6,2); }  // ;
        if(tile == 45) { c64_key = MATRIX(6,5); }  // =
        if(tile == 46) { c64_key = MATRIX(0,1); }  // Return

        if(tile == 47) { c64_key = MATRIX(7,5); }  // C=
        if(tile == 48) { c64_key = MATRIX(1,7); }  // Shift Left
        if(tile == 49) { c64_key = MATRIX(1,4); }  // Z
        if(tile == 50) { c64_key = MATRIX(2,7); }  // X
        if(tile == 51) { c64_key = MATRIX(2,4); }  // C
        if(tile == 52) { c64_key = MATRIX(3,7); }  // V
        if(tile == 53) { c64_key = MATRIX(3,4); }  // B
        if(tile == 54) { c64_key = MATRIX(4,7); }  // N
        if(tile == 55) { c64_key = MATRIX(4,4); }  // M
        if(tile == 56) { c64_key = MATRIX(5,7); }  // ,
        if(tile == 57) { c64_key = MATRIX(5,4); }  // .
        if(tile == 58) { c64_key = MATRIX(6,7); }  // /
        if(tile == 59) { c64_key = MATRIX(6,4); }  // Shift Right
        if(tile == 60) { c64_key = MATRIX(0,7); }  // CRSR Up/Down
        if(tile == 61) { c64_key = MATRIX(0,2); }  // CRSR Left/Right

        if(tile == 62) { c64_key = MATRIX(7,4); }  // Space

        if(tile == 63) { c64_key = MATRIX(0,4); }  // F1
        if(tile == 64) { c64_key = MATRIX(0,5); }  // F3
        if(tile == 65) { c64_key = MATRIX(0,6); }  // F5
        if(tile == 66) { c64_key = MATRIX(0,3); }  // F6
        
        if(tile >0 && tile<67){
            keyHeld = tile - 1;
        }

   
        drawKey(0,0,1,keyHeld, 1);

        if(oldKeyHeld != keyHeld){
            drawKey(0,0,1,oldKeyHeld, 0);

              if( tile==48 || tile == 59){
                //shifted = !shifted;
                drawKeyboard();
              //  redrawLowerScreen=true;
              }

        }

        oldKeyHeld = keyHeld;
        
    } // if touch
    
    

    // check newpress keys for shift lock
    if(keys_down & keyTouch ){
        if(c64_key == MATRIX(1,7) || c64_key == MATRIX(6,4)) shifted = !shifted;
        if(c64_key == MATRIX(7,5)) cmbed = !cmbed;
        if(c64_key == MATRIX(7,2)) ctrled = !ctrled;
        drawKeyboard();
    } // if touch

    
    
    if (lastc64key >-1 ){ KeyRelease(lastc64key, key_matrix, rev_matrix); }
    if(c64_key != -1){
        if(shifted == 1) {c64_key|=128;}
        //if(ctrled == 1) {c64_key|=128;}
        
        KeyPress(c64_key, key_matrix, rev_matrix);
	   lastc64key=c64_key;
    }
    

    
    
} // filesGot == 0

    
    
    
    
oldTouch = keyTouch; 
keyTouch = KEY_TOUCH;

}


/*
 *  Check if NumLock is down (for switching the joystick keyboard emulation)
 */

bool C64Display::NumLock(void)
{
    return false;
}


/*
 *  Allocate C64 colors
 */


typedef struct {
    int r;
    int g;
    int b;
} plt;

static plt palette[256];

void C64Display::InitColors(uint8 *colors)
{
  for (int i = 0; i < 16; i++) {
		palette[i].r = palette_red[i];
		palette[i].g = palette_green[i];
		palette[i].b = palette_blue[i];
      colours[i] = palette_blue[i] + (palette_green[i] << 8) + (palette_red[i] << 16);
  }


	// frodo internal 8 bit palette
	for(int i=0; i<256; i++) {
		colors[i] = (i) & 0x0f;
	}
}


/*
 *  Show a requester (error message)
 */

long int ShowRequester(char *a,char *b,char *)
{
//	iprintf("%s: %s\n", a, b);
	return 1;
}

