/*
 * 32x24 hit data
 */
#define F_1	0x1
#define F_2	0x2
#define F_3	0x3
#define F_4	0x4
#define F_5	0x5
#define F_6	0x6
#define F_7	0x7
#define F_8	0x18

#define LFA	0x095 //Left arrow
#define CLR 0x147
#define PND 0x92

#define RST 0x13 // Restore
#define RET	'\n' // Enter
#define BSP	0x8 // Backspace
#define	CTR	0x21 // Ctrl
#define SPC	0x20// Space
#define ATT	0x22 // At@
#define UPA 0x23 //uparrow symbol
#define RUN	0x0 // RunStop
#define SLK	0x25 // Shift Lock
#define CMD 0x26 // Commodore key
#define SHF 0x27 // Shift Key

#define CUP	0x14 // Cursor up
#define CDL	0x15 // Cursor left

const unsigned char keyboard_Hit[512] = {
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
LFA,LFA,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','+','+','-','-',PND,PND,CLR,CLR,BSP,BSP,
LFA,LFA,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','+','+','-','-',PND,PND,CLR,CLR,BSP,BSP,
CTR,CTR,CTR,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P',ATT,ATT,'*','*',UPA,UPA,RST,RST,RST,
CTR,CTR,CTR,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P',ATT,ATT,'*','*',UPA,UPA,RST,RST,RST,
RUN,RUN,SLK,SLK,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':',';',';','=','=',RET,RET,RET,RET,
RUN,RUN,SLK,SLK,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':',';',';','=','=',RET,RET,RET,RET,
CMD,CMD,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,CUP,CUP,CDL,CDL,
CMD,CMD,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,CUP,CUP,CDL,CDL,
0x0,0x0,0x0,0x0,0x0,0x0,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,F_1,F_1,F_3,F_3,F_5,F_5,F_7,F_7,
0x0,0x0,0x0,0x0,0x0,0x0,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,F_1,F_1,F_3,F_3,F_5,F_5,F_7,F_7,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
};

const unsigned char keyboard_Hit_Shift[512] = {
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,BSP,BSP,
LFA,LFA,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','+','+','-','-',PND,PND,CLR,CLR,BSP,BSP,
LFA,LFA,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','+','+','-','-',PND,PND,CLR,CLR,BSP,BSP,
CTR,CTR,CTR,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P',ATT,ATT,'*','*',UPA,UPA,RST,RST,RST,
CTR,CTR,CTR,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P',ATT,ATT,'*','*',UPA,UPA,RST,RST,RST,
RUN,RUN,SLK,SLK,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':',';',';','=','=',RET,RET,RET,RET,
RUN,RUN,SLK,SLK,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':',';',';','=','=',RET,RET,RET,RET,
CMD,CMD,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,CUP,CUP,CDL,CDL,
CMD,CMD,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,CUP,CUP,CDL,CDL,
0x0,0x0,0x0,0x0,0x0,0x0,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,F_1,F_1,F_3,F_3,F_5,F_5,F_7,F_7,
0x0,0x0,0x0,0x0,0x0,0x0,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,SPC,F_1,F_1,F_3,F_3,F_5,F_5,F_7,F_7,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
};
